<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Fontset</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Fontset<br/>
<small>
[<a class="el" href="group__m17nGUI.html">GUI API</a>]</small>
</h1>
<p>A fontset is an object that maps a character to fonts.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFontset.html#ga24016779ca68b4e494e0948a23abe5c2">mfontset</a> (char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return a fontset.  <a href="#ga24016779ca68b4e494e0948a23abe5c2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFontset.html#gaba7c57d1f743707d7229bf2877de3619">mfontset_name</a> (<a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *fontset)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the name of a fontset.  <a href="#gaba7c57d1f743707d7229bf2877de3619"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFontset.html#ga91fcf191cd137b2a8b3172ca0a7fa2a3">mfontset_copy</a> (<a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *fontset, char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Make a copy of a fontset.  <a href="#ga91fcf191cd137b2a8b3172ca0a7fa2a3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFontset.html#ga51d2984c48e258573c6c97a6b562e8b2">mfontset_modify_entry</a> (<a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *fontset, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> script, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> charset, <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *spec, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> layouter_name, int how)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Modify the contents of a fontset.  <a href="#ga51d2984c48e258573c6c97a6b562e8b2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFontset.html#gaa18800b40d14683b9266150f836a9a69">mfontset_lookup</a> (<a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *fontset, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> script, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> charset)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Lookup a fontset.  <a href="#gaa18800b40d14683b9266150f836a9a69"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>A fontset is an object that maps a character to fonts. </p>
<p>A <em>fontset</em> is an object of the type <code>MFontset</code>. When drawing an M-text, a fontset provides rules to select a font for each character in the M-text according to the following information.</p>
<ul>
<li>The script character property of a character. </li>
<li>The language text property of a character. </li>
<li>The charset text property of a character.</li>
</ul>
<p>The documentation of <a class="el" href="group__m17nDraw.html#ga02f9efd2c5d1bdd9d7a6ab18475bbd08" title="Draw an M-text on a window.">mdraw_text()</a> describes how that information is used. </p>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga24016779ca68b4e494e0948a23abe5c2"></a><!-- doxytag: member="m17n&#45;gui.h::mfontset" ref="ga24016779ca68b4e494e0948a23abe5c2" args="(char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> * mfontset </td>
          <td>(</td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return a fontset. </p>
<p>The <a class="el" href="group__m17nFontset.html#ga24016779ca68b4e494e0948a23abe5c2" title="Return a fontset.">mfontset()</a> function returns a pointer to a fontset object of name <b>name</b>. If <b>name</b> is <code>NULL</code>, it returns a pointer to the default fontset.</p>
<p>If no fontset has the name <b>name</b>, a new one is created. At that time, if there exists a data &lt;<code>fontset</code>, <b>name&gt;</b> in the m17n database, the fontset contents are initialized according to the data. If no such data exists, the fontset contents are left vacant.</p>
<p>The macro <a class="el" href="group__m17nIntro.html#ga66879b35a1fee08b3e5966f6650c39f9" title="Initialize the m17n library.">M17N_INIT()</a> creates the default fontset. An application program can modify it before the first call of <a class="el" href="group__m17nFrame.html#ga8fa9ad4e45dff9703c471d4b243eb674" title="Create a new frame.">mframe()</a>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns a pointer to the found or newly created fontset. </dd></dl>

</div>
</div>
<a class="anchor" id="gaba7c57d1f743707d7229bf2877de3619"></a><!-- doxytag: member="m17n&#45;gui.h::mfontset_name" ref="gaba7c57d1f743707d7229bf2877de3619" args="(MFontset *fontset)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> mfontset_name </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td>
          <td class="paramname"> <em>fontset</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the name of a fontset. </p>
<p>The <a class="el" href="group__m17nFontset.html#gaba7c57d1f743707d7229bf2877de3619" title="Return the name of a fontset.">mfontset_name()</a> function returns the name of fontset <b>fontset</b>. </p>

</div>
</div>
<a class="anchor" id="ga91fcf191cd137b2a8b3172ca0a7fa2a3"></a><!-- doxytag: member="m17n&#45;gui.h::mfontset_copy" ref="ga91fcf191cd137b2a8b3172ca0a7fa2a3" args="(MFontset *fontset, char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> * mfontset_copy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td>
          <td class="paramname"> <em>fontset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Make a copy of a fontset. </p>
<p>The <a class="el" href="group__m17nFontset.html#ga91fcf191cd137b2a8b3172ca0a7fa2a3" title="Make a copy of a fontset.">mfontset_copy()</a> function makes a copy of fontset <b>fontset</b>, gives it a name <b>name</b>, and returns a pointer to the created copy. <b>name</b> must not be a name of existing fontset. In such case, this function returns NULL without making a copy. </p>

</div>
</div>
<a class="anchor" id="ga51d2984c48e258573c6c97a6b562e8b2"></a><!-- doxytag: member="m17n&#45;gui.h::mfontset_modify_entry" ref="ga51d2984c48e258573c6c97a6b562e8b2" args="(MFontset *fontset, MSymbol script, MSymbol language, MSymbol charset, MFont *spec, MSymbol layouter_name, int how)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfontset_modify_entry </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td>
          <td class="paramname"> <em>fontset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>script</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>language</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>charset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>spec</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>layouter_name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>how</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Modify the contents of a fontset. </p>
<p>The <a class="el" href="group__m17nFontset.html#ga51d2984c48e258573c6c97a6b562e8b2" title="Modify the contents of a fontset.">mfontset_modify_entry()</a> function associates, in fontset <b>fontset</b>, a copy of <b>font</b> with the <b>script</b> / <b>language</b> pair or with <b>charset</b>.</p>
<p>Each font in a fontset is associated with a particular script/language pair, with a particular charset, or with the symbol <code>Mnil</code>. The fonts that are associated with the same item make a group.</p>
<p>If <b>script</b> is not <code>Mnil</code>, it must be a symbol identifying a script. In this case, <b>language</b> is either a symbol identifying a language or <code>Mnil</code>, and <b>font</b> is associated with the <b>script</b> / <b>language</b> pair.</p>
<p>If <b>charset</b> is not <code>Mnil</code>, it must be a symbol representing a charset object. In this case, <b>font</b> is associated with that charset.</p>
<p>If both <b>script</b> and <b>charset</b> are not <code>Mnil</code>, two copies of <b>font</b> are created. Then one is associated with the <b>script</b> / <b>language</b> pair and the other with that charset.</p>
<p>If both <b>script</b> and <b>charset</b> are <code>Mnil</code>, <b>font</b> is associated with <code>Mnil</code>. This kind of fonts are called <em>fallback</em> <em>fonts</em>.</p>
<p>The argument <b>how</b> specifies the priority of <b>font</b>. If <b>how</b> is positive, <b>font</b> has the highest priority in the group of fonts that are associated with the same item. If <b>how</b> is negative, <b>font</b> has the lowest priority. If <b>how</b> is zero, <b>font</b> becomes the only available font for the associated item; all the other fonts are removed from the group.</p>
<p>If <b>layouter_name</b> is not <code>Mnil</code>, it must be a symbol representing a <a class="el" href="m17nDBFormat.html#mdbFLT">Font Layout Table</a> (font layout table). In that case, if <b>font</b> is selected for drawing an M-text, that font layout table is used to generate a glyph code sequence from a character sequence.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nFontset.html#ga51d2984c48e258573c6c97a6b562e8b2" title="Modify the contents of a fontset.">mfontset_modify_entry()</a> returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_SYMBOL</code> </dd></dl>

</div>
</div>
<a class="anchor" id="gaa18800b40d14683b9266150f836a9a69"></a><!-- doxytag: member="m17n&#45;gui.h::mfontset_lookup" ref="gaa18800b40d14683b9266150f836a9a69" args="(MFontset *fontset, MSymbol script, MSymbol language, MSymbol charset)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> * mfontset_lookup </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td>
          <td class="paramname"> <em>fontset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>script</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>language</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>charset</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Lookup a fontset. </p>
<p>The <a class="el" href="group__m17nFontset.html#gaa18800b40d14683b9266150f836a9a69" title="Lookup a fontset.">mfontset_lookup()</a> function lookups <b>fontset</b> and returns a plist that describes the contents of <b>fontset</b> corresponding to the specified script, language, and charset.</p>
<p>If <b>script</b> is <code>Mt</code>, keys of the returned plist are script name symbols for which some fonts are specified and values are NULL.</p>
<p>If <b>script</b> is a script name symbol, the returned plist is decided by <b>language</b>.</p>
<ul>
<li>If <b>language</b> is <code>Mt</code>, keys of the plist are language name symbols for which some fonts are specified and values are NULL. A key may be <code>Mt</code> which means some fallback fonts are specified for the script.</li>
</ul>
<ul>
<li>If <b>language</b> is a language name symbol, the plist is a <code>FONT-GROUP</code> for the specified script and language. <code>FONT-GROUP</code> is a plist whose keys are FLT (FontLayoutTable) name symbols (<code>Mt</code> if no FLT is associated with the font) and values are pointers to <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d" title="Type of fonts.">MFont</a>.</li>
</ul>
<ul>
<li>If <b>language</b> is <code>Mnil</code>, the plist is fallback <code>FONT-GROUP</code> for the script.</li>
</ul>
<p>If <b>script</b> is <code>Mnil</code>, the returned plist is decided as below.</p>
<ul>
<li>If <b>charset</b> is <code>Mt</code>, keys of the returned plist are charset name symbols for which some fonts are specified and values are NULL.</li>
</ul>
<ul>
<li>If <b>charset</b> is a charset name symbol, the plist is a <code>FONT-GROUP</code> for the charset.</li>
</ul>
<ul>
<li>If <b>charset</b> is <code>Mnil</code>, the plist is a fallback <code>FONT-GROUP</code>.</li>
</ul>
<dl class="user"><dt><b>Return value:</b></dt><dd>It returns a plist describing the contents of a fontset. The plist should be freed by <a class="el" href="group__m17nObject.html#ga248ba287a615a2cf3cdb99c13275453b" title="Decrement the reference count of a managed object.">m17n_object_unref()</a>. </dd></dl>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
